<!-- Subnet Buddy; Version 0.1; Author: Mark Rogoyski -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
	<title>Subnet Buddy</title>
	<style type="text/css">
		div#results {
			width: 800px;
			margin: 0 auto;
		}
		table#main, #main th, #main td {
			border-collapse: collapse;
			border: 1px solid black;
			padding: 3px;
		}
		th {background-color: lightgrey;}
		td.mono {font-family: Courier;}
	</style>
</head>
<body>

<?php
// Validate Input IP Address
if (!is_numeric($_POST["ip1"])) {
	echo "Bad input IP Address (First section: " . $_POST["ip1"] . ").";
} elseif (!is_numeric($_POST["ip2"])) {
	echo "Bad input IP Address (Second section: " . $_POST["ip2"] . ").";
} elseif (!is_numeric($_POST["ip3"])) {
	echo "Bad input IP Address (Third section: " . $_POST["ip3"] . ").";
} elseif (!is_numeric($_POST["ip4"])) {
	echo "Bad input IP Address (Fourth section: " . $_POST["ip4"] . ").";
} else if (($_POST["ip1"] > 255) || ($_POST["ip1"] < 0)) {
	echo "Bad input IP Address (First section: " . $_POST["ip1"] . ").";
} else if (($_POST["ip2"] > 255) || ($_POST["ip2"] < 0)) {
	echo "Bad input IP Address (Second section: " . $_POST["ip2"] . ").";
} else if (($_POST["ip3"] > 255) || ($_POST["ip3"] < 0)) {
	echo "Bad input IP Address (Third section: " . $_POST["ip3"] . ").";
} else if (($_POST["ip4"] > 255) || ($_POST["ip4"] < 0)) {
	echo "Bad input IP Address (Fourth section: " . $_POST["ip4"] . ").";
} else {

define("ADDRESS_SIZE", 32);
$address = array($_POST["ip1"], $_POST["ip2"], $_POST["ip3"], $_POST["ip4"]);
$mask = $_POST["CIDRMask"];
?>

<h1 style="text-align: center; margin-bottom: 5px; margin-top: 5px;">Subnet Buddy</h1>
<p style="text-align: center; margin-top: 0px;">Subnet mask and other classless (CIDR) network information calculations for: 
<?php 
		$dots = 3;
		foreach ($address as $value) {
			printf("%d", $value);
			$dots -= 1;
			if ($dots >= 0) { echo "."; }
		} 
		echo "/$mask"; ?></p>

<div id="results">
<table id="main">
<tr>
	<th><?php 
		$dots = 3;
		foreach ($address as $value) {
			printf("%d", $value);
			$dots -= 1;
			if ($dots >= 0) { echo "."; }
		} 
		echo "/$mask"; ?>
	</th>
	<th>Dot-Decimal Notation</th>
	<th>Hexadecimal Notation</th>
	<th>Binary Notation</th>
</tr>
<tr>
	<td>IP Address</td>
	<td><?php 
		$dots = 3;
		foreach ($address as $value) {
			printf("%d", $value);
			$dots -= 1;
			if ($dots >= 0) { echo "."; }
		} ?>
	</td>
	<td class="mono"><?php
		foreach ($address as $value) {
			printf("%02X", $value);
		} ?>
	</td>
	<td class="mono"><?php
		$spaces = 3;
		foreach ($address as $value) {
			printf("%08b", $value);
			$spaces -= 1;
			if ($spaces >= 0) { echo " "; }
		} ?>
	</td>
</tr>
<tr>
	<td>Subnet Mask</td>
	<td><?php
		$subnet = 0xFFFFFFFF << (ADDRESS_SIZE - $mask);
		printf("%d.", ($subnet >> 24) & 0xFF);
		printf("%d.", ($subnet >> 16) & 0xFF);
		printf("%d.", ($subnet >> 8) & 0xFF);
		printf("%d",  $subnet & 0xFF); ?>
	</td>
	<td class="mono"><?php
		printf("%02X", ($subnet >> 24) & 0xFF);
		printf("%02X", ($subnet >> 16) & 0xFF);
		printf("%02X", ($subnet >> 8) & 0xFF);
		printf("%02X",  $subnet & 0xFF); ?>
	</td>
	<td class="mono"><?php
		printf("%08b ", ($subnet >> 24) & 0xFF);
		printf("%08b ", ($subnet >> 16) & 0xFF);
		printf("%08b ", ($subnet >> 8) & 0xFF);
		printf("%08b",  $subnet & 0xFF); ?>
	</td>
</tr>
<tr>
	<td>Network Portion</td>
	<td><?php
		$dots = 3; $shift = 24;
		foreach ($address as $value) {
			$networkPortion = $value & (($subnet >> $shift) & 0xFF);
			printf("%d", $networkPortion);
			$dots -= 1;
			if ($dots >= 0) { echo "."; }
			$shift -= 8;
		} ?>
	</td>
	<td class="mono"><?php
		$shift = 24;
		foreach ($address as $value) {
			$networkPortion = $value & (($subnet >> $shift) & 0xFF);
			printf("%02X", $networkPortion);
			$shift -= 8;
		} ?>
	</td>
	<td class="mono"><?php
		$spaces = 3; $shift = 24;
		foreach ($address as $value) {
			$networkPortion = $value & (($subnet >> $shift) & 0xFF);
			printf("%08b", $networkPortion);
			$spaces -= 1;
			if ($spaces >= 0) { echo " "; }
			$shift -= 8;
		} ?>
	</td>
</tr>
<tr>
	<td>Host Portion</td>
	<td><?php
		$dots = 3; $shift = 24;
		foreach ($address as $value) {
			$networkPortion = $value & ~(($subnet >> $shift) & 0xFF);
			printf("%d", $networkPortion);
			$dots -= 1;
			if ($dots >= 0) { echo "."; }
			$shift -= 8;
		} ?>
	</td>
	<td class="mono"><?php
		$shift = 24;
		foreach ($address as $value) {
			$networkPortion = $value & ~(($subnet >> $shift) & 0xFF);
			printf("%02X", $networkPortion);
			$shift -= 8;
		} ?>	
	</td>
	<td class="mono"><?php
		$spaces = 3; $shift = 24;
		foreach ($address as $value) {
			$networkPortion = $value & ~(($subnet >> $shift) & 0xFF);
			printf("%08b", $networkPortion);
			$spaces -= 1;
			if ($spaces >= 0) { echo " "; }
			$shift -= 8;
		} ?>	
	</td>
</tr>
</table>
<br/>

<?php
	$numberIPAddresses = pow(2, (ADDRESS_SIZE - $mask));
	if ($mask == 32)
		$numberAddressableHosts = 1;
	elseif ($mask == 31)
		$numberAddressableHosts = 2;
	else
		$numberAddressableHosts = $numberIPAddresses - 2;
?>

<table>
<tr><td>Number of IP Addresses:</td><td> <?php echo number_format($numberIPAddresses); ?></td>
<tr><td>Number of Addressable Hosts:</td><td> <?php echo number_format($numberAddressableHosts); ?></td></tr>
<tr>
<td>IP Address Range:</td>
<td>
<?php
		$dots = 3; $shift = 24;
		foreach ($address as $value) {
			$networkPortion = $value & (($subnet >> $shift) & 0xFF);
			printf("%d", $networkPortion);
			$dots -= 1;
			if ($dots >= 0) { echo "."; }
			$shift -= 8;
		} ?>
 - 
<?php
		$dots = 3; $shift = 24;
		foreach ($address as $value) {
			$networkPortion = ($value & (($subnet >> $shift) & 0xFF)) + ((($numberIPAddresses -1) >> $shift) & 0xFF);
			printf("%d", $networkPortion);
			$dots -= 1;
			if ($dots >= 0) { echo "."; }
			$shift -= 8;
		} ?>
</td>
</tr>
<tr>
<td>Broadcast Address:</td>
<td>
<?php
		$dots = 3; $shift = 24;
		foreach ($address as $value) {
			$networkPortion = ($value & (($subnet >> $shift) & 0xFF)) + ((($numberIPAddresses -1) >> $shift) & 0xFF);
			printf("%d", $networkPortion);
			$dots -= 1;
			if ($dots >= 0) { echo "."; }
			$shift -= 8;
		} ?>
</td>
</tr>
</table>
</div>
</body>
</head>

<?php } ?>
